Bug 845107 - Review Request: rubygem-openshift-origin-msg-broker-mcollective - OpenShift Origin plugin for mcollective service
Review Request: rubygem-openshift-origin-msg-broker-mcollective - OpenShift O...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Nalley
Fedora Extras Quality Assurance
:
: 841641 (view as bug list)
Depends On: 839064
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-01 15:14 EDT by Adam Miller
Modified: 2012-12-15 13:10 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-27 01:08:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
limburgher: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Adam Miller 2012-08-01 15:14:07 EDT
Spec URL: http://maxamillion.fedorapeople.org/openshift-origin-msg-broker-mcollective.spec
SRPM URL: http://maxamillion.fedorapeople.org/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-2.fc17.src.rpm
Description: OpenShift Origin plugin for mcollective based node/gear manager
Fedora Account System Username: maxamillion tdawson
Comment 1 Adam Miller 2012-08-01 15:15:04 EDT
*** Bug 841641 has been marked as a duplicate of this bug. ***
Comment 2 David Nalley 2012-08-06 19:52:36 EDT
I will take this one, and have a review done shortly
Comment 3 David Nalley 2012-08-06 20:08:54 EDT
[      ] MUST: rpmlint must be run on the source rpm and all binary rpms the
         build produces. The output should be posted in the review.(refer to
         
[ke4qqq@mba SPECS]$ rpmlint ./openshift-origin-msg-broker-mcollective.spec ../RPMS/noarch/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-2.fc17.noarch.rpm ../SRPMS/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-2.fc17.src.rpm 
./openshift-origin-msg-broker-mcollective.spec:76: W: mixed-use-of-spaces-and-tabs (spaces: line 14, tab: line 76)
./openshift-origin-msg-broker-mcollective.spec: W: invalid-url Source0: https://mirror.openshift.com/pub/crankcase/source/rubygem-openshift-origin-msg-broker-mcollective/rubygem-openshift-origin-msg-broker-mcollective-0.1.1.tar.gz HTTP Error 404: Not Found
rubygem-openshift-origin-msg-broker-mcollective.noarch: W: unexpanded-macro /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/GearChanger/MCollectiveApplicationContainerProxy/has_app%3f-i.ri %3f
rubygem-openshift-origin-msg-broker-mcollective.noarch: W: unexpanded-macro /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/GearChanger/MCollectiveApplicationContainerProxy/has_uid_or_gid%3f-i.ri %3f
rubygem-openshift-origin-msg-broker-mcollective.noarch: W: unexpanded-macro /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/GearChanger/MCollectiveApplicationContainerProxy/has_embedded_app%3f-i.ri %3f
rubygem-openshift-origin-msg-broker-mcollective.noarch: W: unexpanded-macro /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/GearChanger/MCollectiveApplicationContainerProxy/blacklisted_in_impl%3f-c.ri %3f
rubygem-openshift-origin-msg-broker-mcollective.noarch: E: script-without-shebang /usr/share/gems/gems/openshift-origin-msg-broker-mcollective-0.1.1/lib/gearchanger-mcollective-plugin/gearchanger/mcollective_application_container_proxy.rb
rubygem-openshift-origin-msg-broker-mcollective.noarch: W: dangerous-command-in-%post chown
rubygem-openshift-origin-msg-broker-mcollective.src: E: invalid-spec-name
rubygem-openshift-origin-msg-broker-mcollective.src:76: W: mixed-use-of-spaces-and-tabs (spaces: line 14, tab: line 76)
rubygem-openshift-origin-msg-broker-mcollective.src: W: invalid-url Source0: https://mirror.openshift.com/pub/crankcase/source/rubygem-openshift-origin-msg-broker-mcollective/rubygem-openshift-origin-msg-broker-mcollective-0.1.1.tar.gz HTTP Error 404: Not Found
2 packages and 1 specfiles checked; 2 errors, 9 warnings.http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint)
         
         
A few things to fix there
         
         
[OK] MUST: The package must be named according to the
         http://fedoraproject.org/wiki/Packaging/NamingGuidelines
[FIX] MUST: The spec file name must match the base package
         <code>%{name}</code>, in the format <code>%{name}.spec</code> unless your
         package has an exemption. (refer to
         http://fedoraproject.org/wiki/Packaging/NamingGuidelines#Spec_file_name).
[OK] MUST: The package must meet the
         http://fedoraproject.org/wiki/Packaging/Guidelines.
[OK] MUST: The package must be licensed with a Fedora approved license and
         meet the http://fedoraproject.org/wiki/Packaging/LicensingGuidelines.
[OK] MUST: The License field in the package spec file must match the actual
         license. (refer to
         http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#ValidLicenseShortNames)
         
         
         Since you are part of upstream, please consider asking them to add a license header to the source files. 
         
[OK] MUST: If (and only if) the source package includes the text of the
         license(s) in its own file, then that file, containing the text of the
         license(s) for the package must be included in <code>%doc</code>.(refer to
         http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License Text)
[OK] MUST: The spec file must be written in American English. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#summary)
[OK] MUST: The spec file for the package '''MUST''' be legible. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#Spec_Legibility)
[FIX] MUST: The sources used to build the package must match the upstream
         source, as provided in the spec URL. Reviewers should use md5sum for this task.
         If no upstream URL can be specified for this package, please see the
         http://fedoraproject.org/wiki/Packaging/SourceURL for how to deal with
         this.
         
         The URL in source has disappeared, no idea where the source is, as me manually looking around that site didn't find it either. 
         
[OK] MUST: The package '''MUST''' successfully compile and build into
         binary rpms on at least one primary architecture. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#Architecture_Support)
[NA] MUST: If the package does not successfully compile, build or work on
         an architecture, then those architectures should be listed in the spec in
         <code>ExcludeArch</code>. Each architecture listed in <code>ExcludeArch</code>
         '''MUST''' have a bug filed in bugzilla, describing the reason that the package
         does not compile/build/work on that architecture. The bug number '''MUST''' be
         placed in a comment, next to the corresponding <code>ExcludeArch</code> line.
         (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#Architecture_Build_Failures)
[OK] MUST: All build dependencies must be listed in
         <code>BuildRequires</code>, except for any that are listed in the
         http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2 section of the
         Packaging Guidelines ; inclusion of those as <code>BuildRequires</code> is
         optional. Apply common sense.
[N/A] MUST: The spec file MUST handle locales properly. This is done by
         using the <code>%find_lang</code> macro. Using
         <code>%{_datadir}/locale/*</code> is strictly forbidden.(refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#Handling_Locale_Files)
[N/A] MUST: Every binary RPM package (or subpackage) which stores shared
         library files (not just symlinks) in any of the dynamic linker's default paths,
         must call ldconfig in <code>%post</code> and <code>%postun</code>. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries)
[OK] MUST: Packages must NOT bundle copies of system libraries.(refer to
         http://fedoraproject.org/wiki/Packaging:Guidelines#Duplication_of_system_libraries)
[N/A] MUST: If the package is designed to be relocatable, the packager must
         state this fact in the request for review, along with the rationalization for
         relocation of that specific package. Without this, use of Prefix: /usr is
         considered a blocker. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#RelocatablePackages)
[OK] MUST: A package must own all directories that it creates. If it does
         not create a directory that it uses, then it should require a package which
         does create that directory.  (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#FileAndDirectoryOwnership)
[OK] MUST: A Fedora package must not list a file more than once in the spec
         file's %files listings. (Notable exception: license texts in specific
         situations)(refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles)
[FIX] MUST: Permissions on files must be set properly. Executables should be
         set with executable permissions, for example. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions)
         
         You should be setting permissions in the %files section IMO, not in the %post. 
         
[FIX] MUST: Each package must consistently use macros. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#macros)
         
         Last section of the %file doesn't use macros, why?
         
[OK] MUST: The package must contain code, or permissable content. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#CodeVsContent)
[N/A] MUST: Large documentation files must go in a -doc subpackage. (The
         definition of large is left up to the packager's best judgement, but is not
         restricted to size. Large can refer to either size or quantity). (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation)
[OK] MUST: If a package includes something as %doc, it must not affect the
         runtime of the application. To summarize: If it is in %doc, the program must
         run properly if it is not present. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation)
[N/A] MUST: Header files must be in a -devel package. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages)
[N/A] MUST: Static libraries must be in a -static package. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries)
[N/A] MUST: If a package contains library files with a suffix (e.g.
         libfoo.so.1.1), then library files that end in .so (without suffix) must go in
         a -devel package. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages)
[N/A] MUST: In the vast majority of cases, devel packages must require the
         base package using a fully versioned dependency: <code>Requires:
         %{name}%{?_isa} = %{version}-%{release} </code> (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#RequiringBasePackage)
[N/A] MUST: Packages must NOT contain any .la libtool archives, these must
         be removed in the spec if they are built.(refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries)
[N/A] MUST: Packages containing GUI applications must include a
         %{name}.desktop file, and that file must be properly installed with
         desktop-file-install in the %install section. If you feel that your packaged
         GUI application does not need a .desktop file, you must put a comment in the
         spec file with your explanation. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#desktop)
[OK] MUST: Packages must not own files or directories already owned by
         other packages. The rule of thumb here is that the first package to be
         installed should own the files or directories that other packages may rely
         upon. This means, for example, that no package in Fedora should ever share
         ownership with any of the files or directories owned by the
         <code>filesystem</code> or <code>man</code> package. If you feel that you have
         a good reason to own a file or directory that another package owns, then please
         present that at package review time. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#FileAndDirectoryOwnership)
[OK] MUST: All filenames in rpm packages must be valid UTF-8. (refer to
         http://fedoraproject.org/wiki/Packaging/Guidelines#FilenameEncoding)
    
         
Why are you chmoding/chowning in %post? 

Why are you effectively creating the content for gearchanger-mcollective-plugin.rb in the spec file?
Comment 4 Adam Miller 2012-08-06 20:48:58 EDT
Thanks for picking this up! I've spoken with the upstream author on this and I swear we discussed the reasons for both the heredoc file creation and the chmod/chown in %post but now neither of us can recollect the motivations. I will be doing some heavy refactoring and will get an update to this asap.

-AdamM
Comment 5 Adam Miller 2012-08-07 15:14:04 EDT
Fixed the heredoc (no idea .. don't ask, that was a multi-person oversight) and also fixed the chown/chmod garble in %post.

I have no idea where these are coming from or if they are legitimately an issue: 
    /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/GearChanger/MCollectiveApplicationContainerProxy/has_uid_or_gid%3f-i.ri %3f

I am getting the following against the SRPM but I've unpacked, attempted to find/grep for anything .src and came up empty so I don't know what's going on there.:
    rubygem-openshift-origin-msg-broker-mcollective.src: E: invalid-spec-name

Otherwise I think this version is *much* more acceptable. :)

Spec URL: http://maxamillion.fedorapeople.org/openshift-origin-msg-broker-mcollective.spec
SRPM URL: http://maxamillion.fedorapeople.org/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-3.fc17.src.rpm
Comment 6 David Nalley 2012-08-15 19:09:35 EDT
I am more confused. 
You moved from heredoc to source1 - but you don't do anything with it. (e.g. there is no 'copy'. 
Then you use %ghost in files to tell RPM 'I am not installing this but you still need to know about and own it' 

Also the name of your spec file is still problematic. It's a rubygem, the RPM is rubygem-openshift-origin-msg-broker-mcollective - why are you dropping the rubygem part of that for the spec file name?
Comment 7 Vít Ondruch 2012-08-16 02:48:07 EDT
(In reply to comment #5)
> I have no idea where these are coming from or if they are legitimately an
> issue: 
>    
> /usr/share/gems/doc/openshift-origin-msg-broker-mcollective-0.1.1/ri/
> GearChanger/MCollectiveApplicationContainerProxy/has_uid_or_gid%3f-i.ri %3f

This is rpmlint's false positive.

* BuildRoot, defattrs and %clean section are not required, even for EPEL6 if I am not mistaken.

* Would be nice if you can run a test suite.

* Although you nicely specified the gem macros on the top of the file, you are not using them later in the %files section.
Comment 8 Adam Miller 2012-08-16 09:40:40 EDT
David, I don't entirely follow ... I install %{SOURCE1} on line 78 of the spec file and the %ghost file was specified by the upstream author of the plugin. I will ask for clarification.

No real reason on the naming, I'll rename the specfile.
Comment 10 Adam Miller 2012-08-16 10:57:04 EDT
David,
    I got clarification on the %ghost file entry. That file originates from, and it provided by, the mcollective package but is required by this package. The configuration file can be modified using an utility provided within this plugin.
Comment 11 Vít Ondruch 2012-08-17 03:13:11 EDT
(In reply to comment #9)
> Vit - I've updated with your feedback.

Thank you.

* ruby_sitelib is not needed.

* You should not own %{gem_dir}
  - The idea is to own %{gem_instdir}, i.e. %dir %{gem_instdir} and later own
    everything contained in this directory explicitly, e.g. %{gem_libdir},
    %doc %{gem_instdir}/LICENSE.
  - This would unveil to you, that you are duplicating the LICENSE file in the
    output package for example

* Keep the license and readme in original location
  - i.e. you should replace %doc LICENSE with %doc %{gem_instdir}/LICENSE
    (although there is currently discussion about this topic on packaging list).

* Are selinux-policy-targeted and policycoreutils-python required?
  - I did not dug into it too deeply, but are these really needed?

* Test suite
  - What about the test suite? I expect that it will not be that easy, due to
    nature of this package, but I'd like to know at least some feedback (it
    would cover your back at the end)
Comment 12 Troy Dawson 2012-08-17 12:45:06 EDT
One little thing.
Looks like you missed changing rubygem(stickshift-common) to rubygem(openshift-origin-common)
Comment 13 Adam Miller 2012-08-17 15:55:11 EDT
SPEC URL: http://maxamillion.fedorapeople.org/rubygem-openshift-origin-msg-broker-mcollective.spec
SRPM URL: http://maxamillion.fedorapeople.org/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-4.fc17.src.rpm

- Removed unneeded ruby_sitelib

- moved license and readme to original location

- removed policycoreutils-python and selinux-policy-targeted as deps
    After speaking with the upstream author, it was agreed upon that these were not hard requirements.

- changed stickshift-common dep to openshift-origin-common for F18 pkg naming
    This was a complete oversight on my part, apologies

- added doc subpackage
    Was looking at the package manifest and the docs were overpowering so I moved them.


On the topic of a test suite, there currently are not any unit tests listed under the rake task. I spoke with upstream and this is still being planned, currently the testing is done using cucumber in the upstream CI environment and requires a running system/environment to test against so it wouldn't be applicable to the package currently.
Comment 14 Vít Ondruch 2012-08-20 08:28:59 EDT
What is the reason to not use the gem as a Source0 for the package? Why are you using the tarball?
Comment 15 Adam Miller 2012-08-20 12:15:13 EDT
I've always had the impression of "Must Build From Source" when it comes to Fedora packages and have generally defaulted to the tarballs from upstream projects, I'm still rather new to packaging up Ruby bits so if that's not preferred I can switch to the gem.

-AdamM
Comment 16 Vít Ondruch 2012-08-21 01:57:09 EDT
If the gem is platform independent, it always contains the source code. In Ruby world, there is typically no tarball available, so your package would be an exception. And as a last point, guidelines says "The Source of the package must be the full URL to the released Gem archive". Although you could use the "archive" word as a justification, I believe that this word is inappropriate in that sentence and I asked FPC to reword this formulation [1].


[1] https://fedorahosted.org/fpc/ticket/205
Comment 21 David Nalley 2012-09-18 13:37:11 EDT
Adam: 

Sorry for the lag (and thanks for pinging me on the issue)
This looks good now.

APPROVED
Comment 22 Adam Miller 2012-09-18 14:29:52 EDT
New Package SCM Request
=======================
Package Name: rubygem-openshift-origin-msg-broker-mcollective
Short Description: OpenShift Origin plugin for mcollective 
Owners: maxamillion tdawson brenton
Branches: f17 f18
InitialCC:
Comment 23 Jon Ciesla 2012-09-18 14:48:49 EDT
Git done (by process-git-requests).
Comment 24 Jon Ciesla 2012-09-18 14:49:33 EDT
Fixed review flag.
Comment 25 Fedora Update System 2012-09-18 15:53:21 EDT
rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc17
Comment 26 Fedora Update System 2012-09-18 15:53:31 EDT
rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc18
Comment 27 Fedora Update System 2012-09-18 23:03:57 EDT
rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc17 has been pushed to the Fedora 17 testing repository.
Comment 28 Fedora Update System 2012-09-27 01:08:20 EDT
rubygem-openshift-origin-msg-broker-mcollective-0.1.1-9.fc18 has been pushed to the Fedora 18 stable repository.
Comment 29 Fedora Update System 2012-11-29 18:27:05 EST
rubygem-openshift-origin-msg-broker-mcollective-1.0.1-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/rubygem-openshift-origin-msg-broker-mcollective-1.0.1-1.fc17
Comment 30 Fedora Update System 2012-12-06 10:55:36 EST
rubygem-openshift-origin-msg-broker-mcollective-1.1.6-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/rubygem-openshift-origin-msg-broker-mcollective-1.1.6-2.fc17
Comment 31 Fedora Update System 2012-12-15 13:10:19 EST
rubygem-openshift-origin-msg-broker-mcollective-1.1.6-2.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.